#!/user/local/bin/ruby -Ks
def showHelp; scrName = File::basename($0.gsub(/\\/, '/'));
puts <<"================================================"
Tv: asahi press SENTENCE  EBStudio p̓t@C쐬
\: ruby -Ks #{scrName} [<options>] <homeDir> [<outDir>]
  <options>
    -standard  6  4 Ђ (l)
    -single    6  1 Ђ
    -each      6  6 Ђ
               * ȏ́Aʃf[^΂
    -update    ʃf[^̂ݏ
  <homeDir>  fBNg̃[g
  <outDir>   o̓fBNg (wȂȂJgfBNg)
:
* ς݂ SENTENCE 쐬
  ruby -Ks #{scrName} "C:\\Program Files\\Asahi Press SENTENCE" D:\\EPWING\\Asahi
* CD-ROM (X:) 쐬
  ruby -Ks #{scrName} X:\\db D:\\EPWING\\Asahi
* ʃf[^̂ݏ
  ruby -Ks #{scrName} -update "C:\\Program Files\\Asahi Press SENTENCE" D:\\EPWING\\AsahiEX
================================================
end
=begin
o: *.html  EBStudio ̓t@C
      *.ebs   EBStudio Ɗ`t@C
:
  v1.00 2003-02-12 by nomad
    J
  v1.10 2003-02-22 by nomad
    ʃf[^ɑΉ
    -single ȂǂIvVŎw\
    p̓{ꌩo <dfn> 
    AsahiLib.rb 𕪗AȂ
  v1.20 2003-08-07 by nomad
    3񑝗ʃf[^ɑΉ
    ʃf[^͏ɂ܂Ƃ߂ 1 Ђɂ悤ύX
    uCNNdv\Wv̎ނapɒ
    ʃf[^̌oIDɐړǉAȂ
  v1.21 2004-01-11 by nomad
    ruby 1.8 ŃG[ɂȂ̂C (AsahiLib.rb)
  v1.30 2004-02-16 by nomad
    4񑝗ʃf[^ɑΉ

: Copyright (C) 2003-2004, nomad
      I[v\[X
=end

  scrPath = File::dirname($0.gsub(/\\/, '/'))
  scrName = File::basename($0.gsub(/\\/, '/'))
  $LOAD_PATH.unshift(scrPath)     # XNvgpX[hpXɒǉ

  begin
    libName = 'AsahiLib.rb'
    require libName
  rescue LoadError => e
    puts e.message
    puts "Ώ: #{scrName}  #{libName} ̂fBNg"
    puts "      JgfBNgɂāAȂĂ"
    exit 1
  end

  T_STANDARD = 0  # W (4  + )
  T_SINGLE   = 1  # ܂Ƃ߂ďo (1  + )
  T_EACH     = 2  # ʂɏo (6  + )
  T_UPDATE   = 3  # ʃf[^̂ݏo

  # R}hC̏
  def ARGV.option
    return nil if self.empty?
    arg = self.shift
    if arg =~ /^-/
      return arg
    else
      self.unshift arg
      return nil
    end
  end

  begin
    runType = T_STANDARD
    while option = ARGV.option
      case option
      when '-standard'; runType = T_STANDARD
      when '-single';   runType = T_SINGLE
      when '-each';     runType = T_EACH
      when '-update';   runType = T_UPDATE
      else
        raise 'ȃIvVł: ' + option
      end
    end
    raise 'fBNgw肵Ă' if ARGV.size < 1
  rescue => e
    STDERR.puts e.message
    showHelp()
    exit 1
  end

  ebsType = runType

  # ȂƂ OS/2 łł̓pX؂肪 / łȂƑʖڂȂ̂ŕϊ
  homeDir = ARGV.shift.gsub(/\\/, '/')
  outDir = (ARGV.shift || '.').gsub(/\\/, '/')


  bundleFiles = { T_STANDARD => outDir + '/Waei3.html',
                  T_SINGLE   => outDir + '/AsahiAll.html',
                  T_UPDATE   => outDir + '/Add.html' }
  ebsFiles = { T_STANDARD => outDir + '/asahi.ebs',
               T_SINGLE   => outDir + '/asahiSingle.ebs',
               T_EACH     => outDir + '/asahiEach.ebs',
               T_UPDATE   => outDir + '/asahiUpdate.ebs' }
  copyrightFile = outDir + '/copyright.html'

  dics = {
           'A' => { 'title' => 'wAJꎫTx',
                     'file' => outDir + '/A.html',
                     'type' => 'EJ' },
           '' => { 'title' => 'wĉpꎫTx',
                     'file' => outDir + '/Zoku.html',
                     'type' => 'E' },
           '' => { 'title' => 'wb앶p\Tx',
                     'file' => outDir + '/Kai.html',
                     'type' => 'J' },
           '' => { 'title' => 'wŐVapꎫTx',
                     'file' => outDir + '/Tai.html',
                     'type' => 'J' },
           '\' => { 'title' => 'wŐVČꎫTx',
                     'file' => outDir + '/Hyou.html',
                     'type' => 'JE' },
           'r' => { 'title' => 'urWlXᕶWv',
                     'file' => outDir + '/Bi.html',
                     'type' => 'J' }
         }

  ID_MISC = 'H'

  # v1.20  'file' ͎gpȂ
  extraDics = {
           'b' => { 'title' => 'uCNNdv\Wv',
                     'file' => outDir + '/CNN.html',
                     'type' => 'JE' },
           'V' => { 'title' => 'uVv',
                     'file' => outDir + '/Singo.html',
                     'type' => 'J' },
           '' => { 'title' => 'uwv',
                     'file' => outDir + '/Igaku.html',
                     'type' => 'JE' },
           '' => { 'title' => 'uȊwv',
                     'file' => outDir + '/Kagaku.html',
                     'type' => 'J' },
           'Z' => { 'title' => 'uZprWlXv',
                     'file' => outDir + '/Gibi.html',
                     'type' => 'J' },
           ID_MISC => { 'title' => 'ȗv',
                     'file' => outDir + '/Sonota.html',
                     'type' => 'JE' },
        }

####
=begin
  === NX\

  class AsahiDic
    (ListFile, DataFile, InfFile 𑀍)

  class OutFile < File

  class HTMLWriter
    (OutFile ɏo)
    class EntryHTMLWriter < HTMLWriter
      class EntryHTMLWriterEJ < EntryHTMLWriter
      class EntryHTMLWriterJE < EntryHTMLWriter
      class EntryHTMLWriterE < EntryHTMLWriter
      class EntryHTMLWriterJ < EntryHTMLWriter
    class ExampleHTMLWriter < HTMLWriter

  class EBSFile < File
  class CopyrightFile < File
=end

####
class AsahiDic

  attr_reader :flist, :fdata, :finf

  def initialize(homeDir, files)
    @flist = ListFile::new(homeDir + files['elist'])
    @fdata = DataFile::new(homeDir + files['data'])
    @finf = InfFile::new(homeDir + files['inf'])
    @flist.init
    @fdata.init
    @finf.init
  end

  def getRec(n)
    dic = @flist.dic(n)
    jumps = @finf.jumpList(n)
    return @fdata.getRec(n), dic, jumps
  end

  def checkLink(jumps, dic)
    # ʎւ̃N폜
    jumps.delete_if { |a|
      @flist.dic(a[2] - 1) != dic
    }
    return jumps
  end

  def recCount()
    return @fdata.recCount()
  end

  def close()
    @flist.close
    @fdata.close
    @finf.close
  end

end

####
class OutFile < File

  def writeHeader(title = 'asahi press SENTENCE')
    puts '<html>'
    puts '<head>'
    puts '<title>' + title + '</title>'
    puts '</head>'
    puts '<body>'
    puts '<dl>'
  end

  def writeFooter()
    puts '</dl>'
    puts '</body>'
    puts '</html>'
  end

end

####
class HTMLWriter

  attr_accessor :title, :showsTitle, :idPrefix

  def initialize(file)
    @file = file
    @title = ''
    @showsTitle = false
    @idPrefix = ''
  end

  def writeLines(lines, id)
  end

  def insertAnchor(data, jumps)
    if jumps.size > 0
      s = ''; p = 0
      jumps.each { |a|
        s = s + data[p...a[0]] + '<a href="' + @idPrefix + a[2].to_s + '">' + data[a[0], a[1]] + '</a>'
        p = a[0] + a[1]
      }
      data = s + data[p...data.size]
    end
    return data
  end

  def addKey(s, type)
    # ƃJ^Ji 2 ȏ㑱ĂꍇAL[[hɎw
    s.scan(/[-]{2,}|[@-[]{2,}/).each { |w|
      @file.print '<key type="', type, '">', w, '</key>', "\n"
    }
  end

end

class EntryHTMLWriter < HTMLWriter

  def writeHeadingEJ(lines)
    @file.print '<b>', lines[0], '</b></dt>', "\n"
    addKey(lines[1], 'NX')
    @file.print '<dd><dfn><b>', lines[1], '</b></dfn><br>', "\n"
#    @file.print '<dd><dfn><b>', lines[1], '</b></dfn>', "\n"
#    @file.print '<dd><b>', lines[1], '</b><br>', "\n"
  end
  def writeHeadingJE(lines)
    @file.print '<b>', lines[1], '</b></dt>', "\n"
    addKey(lines[1], 'NX')
    @file.print '<dd><dfn><b>', lines[0], '</b></dfn><br>', "\n"
  end
  def writeHeadingE(lines)
    @file.print '<b>', lines[0], '</b></dt>', "\n"
    @file.print '<dd>'
  end
  def writeHeadingJ(lines)
    @file.print '<b>', lines[1], '</b></dt>', "\n"
    addKey(lines[1], 'NX')
    @file.print '<dd>'
  end

  def writeLines(lines, id)
    @file.print '<dt id="', @idPrefix, id, '">'
    writeHeading(lines)
    if @showsTitle
      @file.print @title, '<br>', "\n"
    end
    for i in 2...lines.size
      @file.print lines[i], '<br>', "\n"
    end
    @file.print '</dd>', "\n"
  end

end

class ExampleHTMLWriter < HTMLWriter

  def writeLines(lines, id)
    @file.print '<dt><b>', lines[0], '</b></dt>', "\n"
    addKey(lines[1], 'NX')
    @file.print '<dd>', lines[1], '<br>', "\n"
    if @showsTitle
      @file.print lines[2], @title, '<br>', "\n"
    else
      @file.print lines[2], '<br>', "\n"
    end
    @file.print '</dd>', "\n"
  end

end

class EntryHTMLWriterEJ < EntryHTMLWriter
  alias writeHeading writeHeadingEJ
end

class EntryHTMLWriterJE < EntryHTMLWriter
  alias writeHeading writeHeadingJE
end

class EntryHTMLWriterE < EntryHTMLWriter
  alias writeHeading writeHeadingE
end

class EntryHTMLWriterJ < EntryHTMLWriter
  alias writeHeading writeHeadingJ
end

####
def createEntryHTMLWriter(type, f)

  case type.upcase
    when 'EJ'
      return EntryHTMLWriterEJ::new(f)
    when 'JE'
      return EntryHTMLWriterJE::new(f)
    when 'E'
      return EntryHTMLWriterE::new(f)
    when 'J'
      return EntryHTMLWriterJ::new(f)
    else
      return nil
  end

end

def createExampleHTMLWriter(type, f)

  return ExampleHTMLWriter::new(f)

end

###
class EBSFile < File

  def printCommon(outDir, copyrightFile)
    puts <<"--------"
OutPath=#{outDir.gsub(/\//, '\\') + '\\'}
IndexFile=
Copyright=#{copyrightFile.gsub(/\//, '\\')}
GaijiFile=
GaijiMapFile=
EBType=0
WordSearchHyoki=1
WordSearchKana=1
EndWordSearchHyoki=1
EndWordSearchKana=1
KeywordSearch=1
ComplexSearch=0
topMenu=0
singleLine=0
kanaSep1=m
kanaSep2=n
makeFig=1
paraHdr=0
ruby=1
paraBr=0
subTitle=0
dfnStyle=0
srchUnit=0
linkChar=0
arrowCode=222A
eijiPronon=1
eijiPartOfSpeech=1
eijiBreak=1
leftMargin=1
indent=0
tableWidth=480
StopWord=a the
delBlank=1
delSym=1
delChars=ij`PQRSTUVWX
refAuto=0
titleWord=1
autoWord=0
HTagIndex=1
DTTagIndex=1
dispKeyInSelList=0
titleOrder=1
channel=0
nBit=0
sampLate=2
optMono=0
Size=40000;20000;4000;15000000;14000;550000;50000;500;500;10000
--------
  end

  def printBook(type, dics, bundleFiles)
    case type
    when T_STANDARD
      puts <<"--------"
Book=AJꎫT;KOUGO;paT;_;_
Source=#{dics['A']['file'].gsub(/\//, '\\')};_;_;HTML;
Book=ĉpꎫT V;ZOKUGO;paT;_;_
Source=#{dics['']['file'].gsub(/\//, '\\')};_;_;HTML;
Book=apꎫT3;WAEI3;apT;_;_
Source=#{bundleFiles[type].gsub(/\//, '\\')};_;_;HTML;
Book=rWlXᕶW;LETTER;apT;_;_
Source=#{dics['r']['file'].gsub(/\//, '\\')};_;_;HTML;
--------
    when T_SINGLE
      puts <<"--------"
Book=asahi press SENTENCE;SENTENCE;paT;_;_
Source=#{bundleFiles[type].gsub(/\//, '\\')};_;_;HTML;
--------
    when T_EACH
      puts <<"--------"
Book=AJꎫT;KOUGO;paT;_;_
Source=#{dics['A']['file'].gsub(/\//, '\\')};_;_;HTML;
Book=ĉpꎫT V;ZOKUGO;paT;_;_
Source=#{dics['']['file'].gsub(/\//, '\\')};_;_;HTML;
Book=b앶p\T V;KAIWA;apT;_;_
Source=#{dics['']['file'].gsub(/\//, '\\')};_;_;HTML;
Book=ŐVapꎫT;WAEI;apT;_;_
Source=#{dics['']['file'].gsub(/\//, '\\')};_;_;HTML;
Book=ŐVČꎫT;NITIBEI;apT;_;_
Source=#{dics['\']['file'].gsub(/\//, '\\')};_;_;HTML;
Book=rWlXᕶW;LETTER;apT;_;_
Source=#{dics['r']['file'].gsub(/\//, '\\')};_;_;HTML;
--------
    end
  end

  def printBookExtra(bundleFiles)
    puts <<"--------"
Book=ʃf[^;ADD;apT;_;_
Source=#{bundleFiles[T_UPDATE].gsub(/\//, '\\')};_;_;HTML;
--------
  end

end

###
class CopyrightFile < File

  def print
    puts <<'--------'
<html>
<head>
<title>CD-ROM̎^e</title>
</head>
<body>
<h1>CD-ROM̎^e (oŎЊ)</h1>
<br>
<ul>
<li><b>wAJꎫTx</b> [A] p/p<br>
ďC: Gh[hEGETCfXebJ[<br>
: WE}P[uAcY<br>
s: 1983N *<br>
</li>
<li><b>wĉpꎫT VŁx</b> [] p<br>
ďC: ͗Y<br>
ҏW: ׎qAav<br>
Z{: }[NEWGAAgj[Ej[G<br>
s: 1996N<br>
</li>
<li><b>wb앶p\T VŁx</b> [] p<br>
ďC: hihEL[AH<br>
ҏW: RcqAɗǕˎq<br>
s: 1986N *<br>
</li>
<li><b>wŐVapꎫTx</b> [] p<br>
ҏW: }[NEWGAH<br>
s: 1992N *<br>
</li>
<li><b>wŐVČꎫTx</b> [\] p/p<br>
ҏW: Gh[hEGETCfXebJ[A{O<br>
s: 1982N *<br>
</li>
<li><b>urWlXᕶWv</b> [r] p<br>
(wCD-ROM ŐVrWlXp莆Tx)<br>
Ғ: tVXEJENfB<br>
s: 1997N (MacAWinΉnCubh)<br>
</li>
</ul>
<p>* 1994ŃwŐVČꎫTxɎ^̍ہAă`FbN</p>
<br>
<h2>ʃf[^</h2>
<br>
<ul>
<li><b>uCNNdv\Wv</b> [b] p<br></li>
<li><b>uVv</b> [V] p<br></li>
<li><b>uwv</b> [] p<br></li>
<li><b>uȊwv</b> [] p<br></li>
<li><b>uZprWlXv</b> [Z] p<br></li>
</ul>
</body>
</html>
--------
  end

end

###
def printHTML(msg, fdic, checkLink, writers)

  STDERR.print msg, "\n"
  jumps = Array::new
  lines = Array::new
  max = count = fdic.recCount

count = 100 if $DEBUG

  count.times { |n|
    STDERR.print n, '/', max, "\r" if n % 100 == 0

    data, dic, jumps = fdic.getRec(n)
    if checkLink == true
      jumps = fdic.checkLink(jumps, dic)
    end
    if writers[dic] == nil
      dic = ID_MISC
    end
    lines = writers[dic].insertAnchor(data, jumps).split("\r")
    writers[dic].writeLines(lines, n + 1)
  }

  STDERR.print count, '/', max, "\n"

end

############################################################# C

  start = Time::now
  STDERR.print "Jn: ", start.strftime('%Y-%m-%d %X'), "\n"

  alias createEntryWriter createEntryHTMLWriter
  alias createExampleWriter createExampleHTMLWriter

  # o̓t@C̏
  fouts = Array::new
  entWriters = Hash::new
  exaWriters = Hash::new

  bundle = proc{ |k, v, p|
    entWriters[k] = createEntryWriter(v['type'], fouts.first)
    entWriters[k].showsTitle = true
    entWriters[k].title = v['title']
    entWriters[k].idPrefix = p
    exaWriters[k] = createExampleWriter(v['type'], fouts.first)
    exaWriters[k].showsTitle = true
    exaWriters[k].title = v['title']
    exaWriters[k].idPrefix = p
  }
  single = proc{ |k, v, p|
    f = OutFile::new(v['file'], 'w')
    fouts.push(f)
    entWriters[k] = createEntryWriter(v['type'], f)
    entWriters[k].showsTitle = false
    entWriters[k].title = v['title']
    entWriters[k].idPrefix = p
    exaWriters[k] = createExampleWriter(v['type'], f)
    exaWriters[k].showsTitle = false
    exaWriters[k].title = v['title']
    exaWriters[k].idPrefix = p
  }

  case runType
  when T_STANDARD  # 4 t@C
    fouts.unshift(OutFile::new(bundleFiles[runType], 'w'))
    dics.each { |k, v|
      case k
        when '', '', '\'
          bundle.call(k, v, '')
        else
          single.call(k, v, '')
      end
    }
    fouts.unshift(OutFile::new(bundleFiles[T_UPDATE], 'w'))
    extraDics.each { |k, v|
      bundle.call(k, v, 'X')
##      single.call(k, v, 'X')
    }
    checkLink = false

  when T_SINGLE  # ꊇt@C
    fouts.unshift(OutFile::new(bundleFiles[runType], 'w'))
    dics.each { |k, v|
      bundle.call(k, v, '')
    }
    fouts.unshift(OutFile::new(bundleFiles[T_UPDATE], 'w'))
    extraDics.each { |k, v|
      bundle.call(k, v, 'X')
##      single.call(k, v, 'X')
    }
    checkLink = false

  when T_EACH  # ʃt@C
    dics.each { |k, v|
      single.call(k, v, '')
    }
    fouts.unshift(OutFile::new(bundleFiles[T_UPDATE], 'w'))
    extraDics.each { |k, v|
      bundle.call(k, v, 'X')
##      single.call(k, v, 'X')
    }
    checkLink = true

  when T_UPDATE  # ʃf[^
    fouts.unshift(OutFile::new(bundleFiles[T_UPDATE], 'w'))
    extraDics.each { |k, v|
      bundle.call(k, v, 'X')
##      single.call(k, v, 'X')
    }
    checkLink = false

  end

  # wb_o
  fouts.each { |f|
    f.writeHeader
  }

  # f[^o
  if runType != T_UPDATE
    fdic = AsahiDic::new(homeDir, EntFiles)
    printHTML('{...', fdic, checkLink, entWriters)
    fdic.close

    fdic = AsahiDic::new(homeDir, ExaFiles)
    printHTML('ᕶ...',fdic, false, exaWriters)
    fdic.close
  end

  fdic = AsahiDic::new(homeDir, EntFiles2)
  addCount = fdic.recCount
  if addCount > 0
    printHTML('ʃf[^{...', fdic, false, entWriters)
    fdic.close

    fdic = AsahiDic::new(homeDir, ExaFiles2)
    printHTML('ʃf[^ᕶ...',fdic, false, exaWriters)
    fdic.close
  else
    STDERR.print 'ʃf[^͂܂', "\n"
  end

  # tb^o
  fouts.each { |f|
    f.writeFooter
    f.close
  }

  # {f[^p ebs t@C̏o
  if runType != T_UPDATE
    EBSFile::open(ebsFiles[ebsType], 'w') { |f|
      f.printCommon(outDir, copyrightFile)
      f.printBook(ebsType, dics, bundleFiles)
    }
  end

  # ʃf[^΁Aʃf[^p ebs t@Co
  if addCount > 0
    EBSFile::open(ebsFiles[T_UPDATE], 'w') { |f|
      if runType == T_UPDATE
        f.printCommon(outDir, copyrightFile)
      else
        f.printCommon(outDir + 'Ex', copyrightFile)
      end
      f.printBookExtra(bundleFiles)
    }
  else
    # f[^t@C폜
    extraDics.each { |k, v|
      begin
        File::delete(v['file'])
      rescue
        STDERR.print v['file'], " 폜ł܂\n"
      end
    }
  end

  # 쌠t@C̏o
  CopyrightFile::open(copyrightFile, 'w') { |f|
    f.print
  }

  finish = Time::now
  STDERR.print "I: ", finish.strftime('%Y-%m-%d %X'), "\n"
  STDERR.print ": ", Time::at(finish.to_i - start.to_i).utc.strftime('%X'), "\n"

exit
